Bug Hunting Session
Bug 58859 - Calc document crashes on closing via API
Summary: Calc document crashes on closing via API
Status: RESOLVED WORKSFORME
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
Master old -3.6
Hardware: x86 (IA32) Linux (All)
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2012-12-29 12:17 UTC by Miday
Modified: 2015-02-28 04:27 UTC (History)
5 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Miday 2012-12-29 12:17:56 UTC
Hi,
I developed the following software.(Japanese)
http://www.ne.jp/asahi/soft/miday/Calc_Moji/Calc_MojiLinux.html

This software processes the data copied from Calc.
This software referred to DocumentLoader.cxx of example and was created.

32bit  http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail32.tar.gz
64bit  http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail64.tar.gz
source http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoM_src.zip
  The command for build.(it performs with the holder of src)
  The comment of source is Japanese.

    src/uni_mst/linux build.sh

Execution environment
  OS: Ubuntu 12.04 32bit / 10.04 64bit(or other version)
  LibreOffice 3.5.6rc2 / 3.5.7.2 / 3.6.4.3
 Java: Sun Microsystems Inc. 1.6.0_24
    (In the case of Ubuntu 12.04 32bit/10.04 32bit/10.04 64bit LibreOffice 3.6.4.3)
  memory: 1GB

Development environment
 OS: Ubuntu 10.04 32bit / 64bit
  LibreOffice SDK and gtk is used.

This software is displaying and creating the book of Calc.
I want to create book by un-displaying.
When Calc has already started, if this software creates a book by un-displaying, Calc will carry out an abnormal end.

------------------------------------------------------
This software carries out the following processing.
(1) Create the book of calc.
(2) It pastes from a clipboard.
(3) Choose the pasted cell in order.
(4) It is processed.
(5) The processed data is outputted to a clipboard.

The place which carries out an abnormal end
  This soft following execution sentence of a CalcSDK.cpp file.
    xCloseable->close(false);

The place which is actually carrying out the abnormal end
  LibreOffice File of sc/source/ui/view/tabvwsh4.cxx ScTabViewShell::~ScTabViewShell() The following execution sentence of a method.
    DELETEZ(pInputHandler);

------------------------------------------------------
The measure method which I considered
 LibreOffice sfx2/source/view/sfxbasecontroller.cxx The following line of a file is looked for.

    DBG_ASSERT( !rFrame.IsInPlace() && !bHasPluginMode, "Special modes not compatible with hidden mode!" );

It has bypassed by adding the following line before the line.

    if ( rDoc.IsHelpDocument() || ( nPluginMode == 2 ) )
      pViewFrame->GetDispatcher()->HideUI( sal_True );
    else
      pViewFrame->GetDispatcher()->HideUI( sal_False );
    pViewFrame->Show();

The sauce which corrected 3.5.6, and built libsfxlo.so file.
It does not operate in 3.6.x.
http://www.ne.jp/asahi/soft/miday/LibreOffice/3.5.6_customize.tar.gz
If libsfxlo.so is replaced with /opt/libreoffice3.5/program/libsfxlo.so, the abnormal end of the calc will not be carried out.
Please return a file, if a test finishes.

I want an addition to inquire.
Or I want me to tell where of source should be corrected.
I do not understand a meaning, program structure, etc. of a variable.
A problem may be in a different place.

------------------------------------------------------
The method of a test
1. The file of CtoMail.ini is created in order to make it hide. (*1)(*2)
2. Calc is started.
3. 20*20 or more large ranges are chosen. (*3)
4. A border is attached. (*4)
5. It copies. (*5)
6. CtoMail_e is double-clicked and started.
7. Since the dialog of the "OK" button is displayed, before pushing "OK", it pastes on an editor. (*6)

(*1) In order to create the window of Calc by hide, the file of CtoMail.ini is created in the same holder as CtoMail_e, and the two following lines are described.

[Evasion]
Evasion=OFF

    Only the loadComponentFromURL method of a CalcSDK.cpp file is influenced by an Evasion parameter.

(*2) When two or more LibreOffice's are installed, a path is specified clearly. Specification of a path writes to the file of CtoMail.ini.

Office_path: The path of the holder with which "soffice.bin" is stored is specified.
Rdb_path:    The path of the holder with which "offapi.rdb" is stored is specified.

ex.
[Path]
Office_path=/opt/libreoffice3.6/program
Rdb_path=/opt/libreoffice3.6/program/types

(*3) A possibility of carrying out an abnormal end becomes high, so that the selection range is large.
(*4) When a border is not attached, since the dialog of "OK/Cancel" is displayed, the "OK" button is pushed.
(*5) It copies from Calc. Calc is not started to copy from an editor.
(*6) The icon of an information is displayed when it is not an abnormal end.
    In the case of an abnormal end, the icon of an error is displayed.
    An abnormal end is not carried out on condition of following.
    - Display a book.
    - Substitute libsfxlo.so by LibreOffice 3.5.x
    - When there are few selected cells

------------------------------------------------------
Sauce which removed processing of a clipboard, and processing of attribute extraction and simplified them from CtoMail_e. A message is English.
http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoTest.tar.gz
  The command for build
    com.sh

This software carries out the following processing.
(1)  Create the book of calc.
(2)  Choose in order the cell specified by CtoMail.ini.

The method of a test
1. Edit the file of CtoMail.ini. (*7)
2. Start Calc.
3. Double-click and start CtoMail_t.

(*7)  Edit the file of CtoMail.ini in the same holder as CtoMail_t. 
Evasion:   "=OFF" It is hide about a window.    "=ON" It is show about a window.
Col :      The number of column of the cell to choose is specified.
Row :      The number of lines of the cell to choose is specified.

ex.
[Evasion]
Evasion=OFF
Col=30
Row=30

If a book is made hide and the value of Col and Row is enlarged, Calc will carry out an abnormal end.
In 64 bits of 3.6.4.3, Calc carries out an abnormal end at the 50*50 place.

Regards,
Comment 1 Michael Stahl (CIB) 2013-01-03 22:07:17 UTC
at first glance this looks like a bug in Calc.

did this work (not crash) in an earlier version of LibreOffice?
Comment 2 Miday 2013-01-06 02:53:55 UTC
> did this work (not crash) in an earlier version of LibreOffice?

Ubuntu 10.04 32bit

The normal end was carried out when tested by Libreoffice 3.4.6rc2.
I think that it has made a mistake in "The measure method which I considered".
Comment 3 Kohei Yoshida 2013-01-09 20:24:54 UTC
His original bug report in Japanese:
http://www.ne.jp/asahi/soft/miday/Calc_Moji/rep_j.txt

(for those of us who can read the language)
Comment 4 Miday 2013-01-16 14:43:02 UTC
I checked up also by Fedora.
  Fedora 16.0 GNOME 32bit LibreOffice 3.4.6  normal end
  Fedora 17.0 GNOME 32bit LibreOffice 3.5.7  abnormal end
  Fedora 17.0 GNOME 64bit LibreOffice 3.5.7  abnormal end

Fedora 32bit CtoM_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/fCtoMail32.tar.gz
Fedora 64bit CtoM_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/fCtoMail64.tar.gz
Fedora 32/64 CtoM_t http://www.ne.jp/asahi/soft/miday/Calc_Moji/fCtoTest.tar.gz

Development environment
  OS: Fedora 17.0 32bit / 64bit
  LibreOffice 3.5.7 SDK and gtk is used.

TestMain.cpp which is the source of EnvTest was modified.
EnvTest only investigated the path, and since there was no necessity of using SDK, it removed it.
EnvTest does not have a direct relation with the problem of bug 58859.
EnvTest of Ubuntu has not updated.
new source     http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoM_src.zip

diff old/TestMain.cpp new/TestMain.cpp
10c10,11
< #include <sal/main.h>
---
> //#include <sal/main.h>
> #include <stdlib.h>
Comment 5 bfoman (inactive) 2013-01-25 12:47:46 UTC
(In reply to comment #4)
> I checked up also by Fedora.
>   Fedora 16.0 GNOME 32bit LibreOffice 3.4.6  normal end
>   Fedora 17.0 GNOME 64bit LibreOffice 3.5.7  abnormal end

Thank you for your report. Could you check this on 4.0 or master as both versions mentioned above reached EndOfLife? If this bug is still reproducible, there is a chance someone will fix it.
Comment 6 Miday 2013-01-29 13:36:23 UTC
(In reply to comment #5)
> Could you check this on 4.0 or master as both
> versions mentioned above reached EndOfLife?

Version 4.0.0.2 (Build ID: 408fe71bd18616c467b3dcd7ab6756528ffcae2)
 Ubuntu 12.04 32bit   abnormal end
 Fedora 17    32bit   abnormal end

I'm sorry.
The portion which checks the version of VersionGet.cpp of source was corrected.
When there was specification of CtoMail.ini, there was a problem which cannot take out the right version of Libreoffice.

CtoMail.ini was also corrected.

The abnormal end of the following file is carried out by 4.0.0.2.

Ubuntu/Fedora 32bit Libreoffice 4.0.0.2
  CtoM_t http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoTest4.tar.gz

Libreoffice is installed in /opt/libreoffice4.0.

Since a path is the same, both of the files of Ubuntu/Fedora become the same action.
What was created by both of Ubuntu/Fedora by way of precaution is contained.
Comment 7 Eike Rathke 2013-01-29 14:47:25 UTC
ASSIGNED is the wrong status here, setting to NEW.
Comment 8 Miday 2013-02-19 13:49:22 UTC
(In reply to comment #7)
Thank you for correcting.

--------------------------------
I upgraded CtoMail_e.
1. It corresponded to LibreOffice 4.0.

2. The archive was divided according to the version of LibreOffice.

3. CtoMail_e was divided into CtoMail_e and CMed. 
  New CtoMail_e sets up LD_LIBRARY_PATH dynamically and performs CMed.
  Former CtoMail_e changed the name into CMed.

Ubuntu/Fedora
LO4.0.0 32bit CtoMail_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail4.0_32.tar.gz
LO4.0.0 64bit CtoMail_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail4.0_64.tar.gz
LO3.6.5 32bit CtoMail_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail3.6_32.tar.gz
LO3.6.5 64bit CtoMail_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail3.6_64.tar.gz
LO3.5.7 32bit CtoMail_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail3.5_32.tar.gz
LO3.5.7 64bit CtoMail_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail3.5_64.tar.gz
new source http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoM_src.zip

LO3.4.6 32bit CtoMail_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail3.4_32.tar.gz
LO3.4.6 64bit CtoMail_e http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail3.4_64.tar.gz

CtoMail3.4 is limited public presentation of only this site.

Even if it does not show Calc, the normal end of CtoMail3.4 is carried out.
If Calc is made un-displaying, the abnormal end of CtoMail3.5/CtoMail3.6/CtoMail4.0 will be carried out.

The method of a test
Calc is started and it is one processing after a copy and of the following,
(1) Double-click CtoMail_e.

(2) It is a terminal,
LD_LIBRARY_PATH=/opt/libreoffice4.0/program:/opt/libreoffice4.0/ure/lib
export LD_LIBRARY_PATH
./CMed

--------------------------------
CtoMail_t has not changed the number of modular as one.
Libreoffice 4.0.0.2
  CtoM_t http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoTest4.tar.gz
Comment 9 QA Administrators 2015-02-19 15:49:05 UTC
** Please read this message in its entirety before responding **

To make sure we're focusing on the bugs that affect our users today, LibreOffice QA is asking bug reporters and confirmers to retest open, confirmed bugs which have not been touched for over a year.

There have been thousands of bug fixes and commits since anyone checked on this bug report. During that time, it's possible that the bug has been fixed, or the details of the problem have changed. We'd really appreciate your help in getting confirmation that the bug is still present.

If you have time, please do the following:

Test to see if the bug is still present on a currently supported version of LibreOffice (4.4.0.3 or later): https://www.libreoffice.org/download/

If the bug is present, please leave a comment that includes the version of LibreOffice and your operating system, and any changes you see in the bug behavior

If the bug is NOT present, please set the bug's Status field to RESOLVED-WORKSFORME and leave a short comment that includes your version of LibreOffice and Operating System

Please DO NOT

Update the version field
Reply via email (please reply directly on the bug tracker)
Set the bug's Status field to RESOLVED - FIXED (this status has a particular meaning that is not appropriate in this case)

Thank you for your help!

-- The LibreOffice QA Team
This NEW Message was generated on: 2015-02-19
Comment 10 Miday 2015-02-28 04:27:55 UTC
The bug does not exist.
I appreciate your debugging.

The following files do not contain the bug.
32bit  http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail4.4_32.tar.gz
64bit  http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoMail4.4_64.tar.gz
source http://www.ne.jp/asahi/soft/miday/Calc_Moji/CtoM_src.zip

Thank you very much!!

Ubuntu 14.04 LTS  32bit/64bit
LibreOffice 4.4.0.3 & Langpack_ja & SDK  32bit/64bit